/******************************************/
/*  Boshiamy Input System Example Program */
/*  Date: July 20, 1995                   */
/*  File name: LIUBIG5.C                  */
/*  Complier Model: Large                 */
/******************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <io.h>
#define MAXLEN 5

unsigned int decode(unsigned char,unsigned char);
void boshiamy(void);
void show_status_line(void);

unsigned int  far *index;
unsigned char far *table, *index_p;
unsigned char input[MAXLEN];
unsigned int  output[10];
int input_len,count;

main()
{
  int i,scr_i;
  long file_size,table_size;

  char ch;
  FILE *fp;

  clrscr();
  if((fp=fopen("liubig5.tab","rb"))==NULL){
     puts("liubig5.tab not found");
     return 0;
  }
  file_size=filelength(fileno(fp));
  table_size=file_size-2050;
  printf("2050 bytes for index table\n");
  printf("%ld bytes for data table\n",table_size);
  printf("%ld words total\n",table_size/3);
  printf("ESC to clear input buffer or quit\n");
  if ((index_p = (char *) malloc(2050))== NULL){
     puts("Not enough memory when alloc index");
     fclose(fp);
     return 0;
  }
  if ((table = (char *) malloc(table_size))==NULL){
     puts("Not enough memory when alloc table");
     free(index_p);
     fclose(fp);
     return 0;
  }
  fread(index_p,1,2050,fp);
  fread(table,1,table_size,fp);
  fclose(fp);

  index=(unsigned int *) index_p;
  /**********************************[This while roop is input control]****/
  input_len=0;
  scr_i=1;
  while(1){
    if(input_len==0)
      gotoxy(scr_i,8);
    else
      gotoxy(input_len+1,10);
    ch=getch();
    if(ch==' '){
      if(input_len>0){
	gotoxy(scr_i,8);
	putch((output[0]>>8)&0xff);
	putch(output[0]&0xff);
	if(scr_i<78)
	  scr_i+=2;
	input_len=0;
	count=0;
	show_status_line();
      }else{
	gotoxy(scr_i,8);
	putch(ch);
	if(scr_i<78)
	   scr_i++;
      }
    }else if(ch==27){          /* ESC*/
      if(input_len==0){
	free(index_p);
	free(table);
	return 0;
      }else{
	input_len=0;
	count=0;
	show_status_line();
      }
    }else if(ch==8){       /* BACKSPACE */
      if(input_len>0){
	input_len--;
	boshiamy();
	show_status_line();
      }else{
	putch(8);
	putch(' ');
	putch(8);
	if(scr_i>1)
	  scr_i--;
      }
    }else if(ch>='1' && ch<='9'){
      i=ch-'1'+1;
      if(i<count){
	gotoxy(scr_i,8);
	putch((output[i]>>8)&0xff);
	putch(output[i]&0xff);
	if(scr_i<78)
	  scr_i+=2;
	input_len=0;
	count=0;
	show_status_line();
      }else{
	gotoxy(scr_i,8);
	putch(ch);
	if(scr_i<78)
	   scr_i++;
      }
    }else if(input_len<MAXLEN && (
	     (ch>='A' && ch<='Z') || (ch>='a' && ch<='z') ||
	     ch==',' || ch=='.' || ch=='\'' || ch=='[' || ch==']')){
      if(ch>='a' && ch<='z')
	ch=ch-'a'+'A';
      input[input_len++]=ch;
      boshiamy();
      show_status_line();
    }
  }
}

void boshiamy(void)
{
   unsigned int i,offset,head,tail,last2,code2,code,count_temp;
   unsigned char in[MAXLEN];
   for(i=0;i<input_len;i++){
      if(input[i]>='A' && input[i]<='Z')
	 in[i]=input[i]-'A'+1;
      else if(input[i]==',')
	 in[i]=27;
      else if(input[i]=='.')
	 in[i]=28;
      else if(input[i]=='\'')
	 in[i]=29;
      else if(input[i]=='[')
	 in[i]=30;
      else if(input[i]==']')
	 in[i]=31;
   }
   for(;i<MAXLEN;i++)
     in[i]=0;
   offset=(unsigned int) in[0]*32+in[1];
   last2 =(unsigned int) in[2]*32+in[3];
   head=index[offset];
   tail=index[offset+1];
   i=head;
   count=0;
   if(input_len==MAXLEN)   /* if input_length is 5, then do nothing */
     i=tail;
   while(i<tail){
     code2=(unsigned int) table[i]*4+table[i+1]/64;
     if(last2==code2){
	output[count++]=decode(table[i+1],table[i+2]);
     }
     i=i+3;
   }
   if(count==0 && input_len>=3 && in[input_len-1]==22){
     in[input_len-1]=0;     /* kill the V and find again */
     last2 =(unsigned int) in[2]*32+in[3];
     i=head;
     while(i<tail){
       code2=(unsigned int) table[i]*4+table[i+1]/64;
       if(last2==code2){
	 count_temp++;
	 if(count_temp==2){     /* the word we want is the 2nd word */
	   count=1;
	   output[0]=decode(table[i+1],table[i+2]);
	   return;
	 }
       }
       i=i+3;
     }
   }
}

unsigned int decode(ch1,ch2)
unsigned char ch1,ch2;
{
  unsigned char high,low;
  unsigned int code;
  code =(unsigned int) (ch1 & 0x3F)*256+ch2;
  high= code/157+0xA1;
  low = code%157;
  if(low<63)
     low=low+0x40;
  else
     low=low-63+0xA1;
  return high*256+low;
}

void show_status_line(void)
{
  int i;
  char status_line[51];
  status_line[50]=0;
  for(i=0;i<50;i++)
    status_line[i]=' ';
  for(i=0;i<input_len;i++){
     status_line[i]=input[i];
  }
  if(count>1){
    status_line[10] = (output[0]>>8) & 0xff;
    status_line[11] = output[0] & 0xff;

    for(i=1;i<count;i++){
      status_line[9 +i*4] =i-1+'1';
      status_line[10+i*4] =(output[i]>>8) & 0xff;
      status_line[11+i*4] =output[i] & 0xff;
    }
  }
  gotoxy(1,10);
  puts(status_line);
}